__Record__ = """CARSRecord product module."""
__version__ = '0.1'

import string, StringIO
from Globals import HTMLFile,MessageDialog,Persistent
import OFS.Folder
import OFS.Image
import Acquisition
import AccessControl
from OFS.content_types import guess_content_type
from Products.CARS.PropertyManager import PropertyClient, PropertyStore
from Products.CARS import Log
from Products.CARS.CARSFolder import CARSFolder
from Products.CARS.CARSObject import CARSObject
from Products.CARS.objBase import objBase

manage_addCARSRecordForm = HTMLFile('carsRecordAdd', globals()) 

def manage_addCARSRecord(self, id, title='', revisioNum=1, REQUEST=None):
    """Add a CARSRecord to a folder."""
    Record=CARSRecord(id, title=title, revisioNum=revisioNum)
    self._setObject(id, Record)
    Record=self._getOb(id)
    Log.carslog(self, 'addCARSRecord(%s)' % repr(id), REQUEST=REQUEST)
    if REQUEST is not None:
        Record.informContacts("Record Added", "CARS Record added: %s" % Record.id)
        return self.manage_main(self, REQUEST)

class CARSRecord(CARSObject.CARSObject): 
    
    __dbgLevelDiagnostic = 0
    __className='CARSRecord'
    
    def __dbg(self, level, dbgLine):
        Log.debug( self.__dbgLevelDiagnostic, level, dbgLine, self.__className)

    meta_type = 'CARS Record'
    __ac_permissions__=CARSObject.CARSObject.__ac_permissions__

    manage_options=CARSObject.CARSObject.manage_options

    def manage_beforeDelete(self, item, container):
        self.__dbg( 1, "manage_beforeDelete")
        return CARSRecord.inheritedAttribute("manage_beforeDelete") (self, item, container)

