import pdb
from Products.ZPatterns.PlugIns import PlugIn
from Products.LoginManager.UserSources import BasicUserSource,LoginUser
from Products.LoginManager.LoginMethods import LoginMethod
from Products.LoginManager import LoginManager
import nis, string, crypt, traceback
from Products.ZPatterns.PlugIns import defaultConstructors

class NisUserSource(BasicUserSource, PlugIn):

    __plugin_kind__ = "User Source"
    meta_type = "NIS User Source"

    f=open('/tmp/zopelog', 'a', 0)
    i=0

    def dbg(self, str):
        self.f.write('[%03d] %s\n' % (self.i, str))
        self.i = self.i + 1

    def path(self, ob):
        r=''
        while 1:
            r = '%s.%s' % (getattr(ob, 'id', '<unknown>'), r)
            if hasattr(ob, 'aq_parent'):
                ob=ob.aq_parent
            else:
                break
        return r
        
    def retrieveItem(self, name):
        if not self.findShareRoot()._hasAnyAccess(name):
            return None
        if not name == "anonymous":
            try: passwd=nis.match(name, 'passwd.byname')
            except nis.error: return None
        user=LoginUser(name)
        user._setRack(self)
        return user
    
    def authenticateUser(self, user, password, REQUEST=None):
        name=user.getUserName()
        if name is None: return None
        if name == "anonymous":
            return 1
        try: passwd=nis.match(name, 'passwd.byname')
        except nis.error: return None
        crypted=string.split(passwd, ':')[1]
        test=crypt.crypt(password, crypted)
        return crypted==test

    def findShareRoot(self):
        ob=self
        while 1:
            if getattr(ob, 'meta_type', None) == 'CARS Share':
                return ob
            if hasattr(ob, 'aq_parent'):
                ob=ob.aq_parent
            else:
                return None
    
    def rolesForUser(self, user):
        user=str(user)
        roles=[]
        ob=self.findShareRoot()
        roles=ob._hasAnyAccess(user)
        return roles
    
    def domainsForUser(self, user):
        return []

def initialize(context):
    context.registerPlugInClass(
        NisUserSource,
        permission = 'Add NIS User Source',
        constructors = defaultConstructors(NisUserSource, globals()),
        )
