class PropertyBase():

    def getPropertyType(self, id):
        """Get the type of property 'id', returning None if no
           such property exists
        """
        for md in self.propertyMap():
            if md['id']==id:
                return md.get('type', 'string')
        return None

    def propertyLabel(self, id):
        """Return a label for the given property id
        """
        for md in self.propertyMap():
            if md['id'] == id:
                return md.get('label', str(id))
        return None

    def propertyDefault(self, id):
        """Return the default value for the given property id
        """
        for md in self.propertyMap():
            if md['id'] == id:
                return md.get('default', None)
        return None

    def valid_property_map_id(self, id):
        if not id or id[:1]=='_' or (' ' in id):
            return 0
        for md in self.propertyMap():
            if md['id'] == id:
                return 0
        return 1
