
__doc__ = """PublishDoc product module."""
__version__ = '0.1'

import string
from DateTime import DateTime
from Globals import HTMLFile,MessageDialog,Persistent
import OFS.Folder
import Acquisition
import AccessControl
from AccessControl import getSecurityManager
from ZPublisher.Converters import get_converter
from Products.CARS.PropertyManager import PropertyServer,PropertyClient,PropertyStore
from Products.CARS import Log
import nis, os, urllib
import Products.CARS.CARSFolder
from types import ListType
from Products.CARS.sendmail import sendmail

manage_publishDocForm = HTMLFile('docPublish', globals())
manage_forwardDocForm = HTMLFile('docForward', globals())

def findStore(self, user):
	share=self
	ob=self
    	while 1:
            if getattr(ob, 'meta_type', None) == 'CARS Share':
                share=ob 
            if hasattr(ob, 'aq_parent'):
                ob=ob.aq_parent
            else:
                if not share:
                    raise 'BadRequest', 'Unable to find parent store folder.'
                start=share
                break 
	try:
		share=getattr(share, 'store')
	except:		
		raise 'BadRequest', 'No Store Folder created.  Contact IT'
	try:
		return getattr(share, str(user))
	except:
		return None

def manage_getStoreList(self, option=None, REQUEST=None):
    	"""Return list of docs found in store."""
	
	def getStoreObjects(store, option=None):
	    docList=[]
	    cnt=0
	    for ob in store.objectValues():
	    	if not (getattr(ob, 'meta_type', None)=='CARS Store Folder'):
			docList.append(ob.id+": "+ob.title)
			cnt=cnt+1
	    if option:
		return cnt
	    return docList

	user=getSecurityManager().getUser()
	store=findStore(self, user)
	if option:
		#return true if user has objects in store
		if store:
			return getStoreObjects(store, "GETTOTAL")
		return 0
	#return list of documents found in user store
	return getStoreObjects(store)

def manage_publishDoc(self, id='', title='', storeFile=[], contact='', REQUEST=None):
	"""Publish Doc to a folder."""
	if not storeFile:
		raise 'Bad Request', 'Please select a file to store'

    	Log.carslog(self, 'publishDoc(%s)' % repr(id), REQUEST=REQUEST)
	user=getSecurityManager().getUser()
	store=findStore(self, user)
	storeObj=None
	if type(storeFile) is ListType:
		for ob in storeFile:
			fileId=ob[:string.find(ob, ":")]
			if not title:
				title=ob[string.find(ob,":")+2:]
	else:
		fileId=storeFile
	if not id:
		id=fileId
	if not id:
		raise 'Bad Request', "Id '%s' is invalid please enter a correct one." % id

	try:
		storeObj=getattr(store, fileId)
	except:
		raise 'Bad Request', "Object '%s' does not exist.  " % fileId +\
		      "Possibly already published."
	storeObj.title=title
	delId=storeObj.id
	if hasattr(self, id):
		raise "Duplicate id", "Another object has the same id %s" % id
	self.manage_pasteObjects(store.manage_cutObjects([delId]), validate_src=0)
	if delId!=id:
		self.manage_renameObjects([delId], [id])
		
	if contact:
		subject="Document published."
		body="Your document '%s' has been published in CARS.  " % title +\
		      "To view it click the link below:\n%s/%s" % (self.absolute_url(), id)
##		sendmail(contact, user, subject, body)
    	if REQUEST is not None:
		self.informContacts("Doc Published", \
				    "CARS Document just published: %s" % self.id)
        	return self.manage_main(self, REQUEST)

def manage_forwardDoc(self, id='', title='', user='', path=None, storeFile=None, REQUEST=None):
	"""Forward Doc to another user."""
	if not storeFile:
		raise 'Bad Request', 'Please select a file to store'
	if not id:
		raise 'Bad Request', "Id '%s' is invalid please enter a correct one." % id
	try:
		nis.match(user, 'passwd.byname')
	except:
		raise 'Bad Request', "User '%s' unknown" % (user)

	app=self.getPhysicalRoot()
	try:
		testPath=app.unrestrictedTraverse(path)
	except:
		raise 'Bad Request', 'Please enter a valid path'

	testPathUrl=testPath.absolute_url()
	store=findStore(self, user)
	if not store:
		store=app.unrestrictedTraverse('/cars/store')
		store.addCARStoreFolder(user,
					title='Store folder for %s' % user)
		store=findStore(self, user)
		
	thisUser=getSecurityManager().getUser()
	thisStore=findStore(self, thisUser)
	storeObj=None
	for ob in storeFile:
		fileId=ob[:string.find(ob, ":")]
	storeObj=getattr(thisStore, fileId)
	delId=storeObj.id
	storeObj._setId(id)
	storeObj.title=title
	store._setObject(id, storeObj)
	args={'id':id, 'title':title, 'storeFile':id, 'contact':thisUser}
	thisStore.manage_delObjects([delId])
	sendmail_success(user, thisUser, title=title,
			 publishUrl=testPathUrl+'/manage_addProduct/CARS/manage_publishDoc',
			 homeUrl=testPathUrl,
			 args=urllib.urlencode(args))
    	if REQUEST is not None:
        	return self.manage_main(self, REQUEST)
	
def sendmail_success(sendTo, sentFrom, title='Untitled document',
		     publishUrl='None', homeUrl='None', args=None):
	subject = 'Add this document to CARS'
	body = "Your authorisation is required to store document '%s' in CARS.\n" % title +\
	     'Click the following link to add document: \n%s?%s\n\n' % (publishUrl, args)+ \
	     'To manually publish the document try the following link:\n%s' % homeUrl
	sendmail(sendTo, sentFrom, subject, body)

class PublishDoc:
	meta_type = "Publish Doc"

class ForwardDoc:
	meta_type = "Forward Doc"
