__doc__ = """CARS initialization module."""

__version__ = '0.1'

from CARSRecord import CARSRecord
from CARSDoc import CARSDoc
from PublishDoc import PublishDoc
from CARSFileGroup import CARSFileGroup
from CARSFolder import CARSFolder
from CARShare import CARShare
from NisLogin import NisLogin

def initialize(context): 
    """Initialize the CARS Product."""

    NisLogin.initialize(context)

    context.registerClass(
	CARSRecord.CARSRecord,
	constructors=(
	CARSRecord.manage_addCARSRecordForm,
	CARSRecord.manage_addCARSRecord,
	),
	icon='images/recordIcon.gif',
	permission='Add CARS Record')

    context.registerClass(
	PublishDoc.PublishDoc,
	constructors=(
	PublishDoc.manage_publishDocForm,
	PublishDoc.manage_publishDoc,
	PublishDoc.manage_getStoreList
	),
	icon='images/docIcon.gif',
	permission='Publish Doc')

#    context.registerClass(
#        PublishDoc.ForwardDoc,
#        constructors=(
#        PublishDoc.manage_forwardDocForm,
#        PublishDoc.manage_forwardDoc
#        ),
#	icon='images/File_icon.gif',
#        permission='Forward Doc')
    
    context.registerClass(
	CARSFileGroup.CARSFileGroup,
	constructors=(
	CARSFileGroup.manage_addCARSFileGroupForm,
	CARSFileGroup.manage_addCARSFileGroup
	),
	icon='images/fileIcon.gif',
	permission='Add CARS File Group',
        permissions=('Add CARS Files',),)

    context.registerClass(
	CARSDoc.CARSDoc,
        constructors=(
	CARSDoc.manage_addCARSDocForm,
	CARSDoc.manage_addCARSDoc
	),
	icon='images/docIcon.gif',
	permission='Add CARS Document',
        permissions=('Add Pages',),)

    context.registerClass(
        CARShare.CARShare,
        constructors=(                
        CARShare.manage_addCARShareForm,
        CARShare.manage_addCARShare
        ),
	icon='images/folderIcon.gif',
        permission='Add CARS Shares')

    context.registerClass(
        CARSFolder.CARStoreFolder,
        constructors=(
        CARSFolder.manage_addCARStoreFolderForm,
        CARSFolder.manage_addCARStoreFolder
        ),
        icon='images/folderIcon.gif',
        permission='Add CARS Store Folders')

    
